Page MenuHomeFreeBSD

Add PD_KILL option to prison_deref()
ClosedPublic

Authored by jamie on Feb 3 2021, 9:43 PM.
Tags
None
Referenced Files
Unknown Object (File)
Tue, Jun 25, 11:37 AM
Unknown Object (File)
Fri, Jun 21, 10:38 AM
Unknown Object (File)
Fri, Jun 21, 8:26 AM
Unknown Object (File)
Thu, Jun 20, 9:52 PM
Unknown Object (File)
Tue, Jun 18, 2:48 AM
Unknown Object (File)
May 23 2024, 5:34 AM
Unknown Object (File)
May 3 2024, 4:41 PM
Unknown Object (File)
May 2 2024, 3:11 AM
Subscribers

Details

Summary

Add the PD_KILL flag that instruction prison_deref() to take steps to actively kill a prison, namely clearing its PR_PERSIST flag and killing any attached processes.

This replaces a similar loop in sys_jail_remove(), bringing the operation under the same single hold on allprison_lock that it already has. It also replaces a bit of one-off code in kern_jail_set() to handle the destruction of almost-finished prisons.

Diff Detail

Repository
rG FreeBSD src repository
Lint
Lint Not Applicable
Unit
Tests Not Applicable

Event Timeline

jamie requested review of this revision.Feb 3 2021, 9:43 PM
jamie created this revision.
This revision was not accepted when it landed; it landed in state Needs Review.Feb 22 2021, 8:28 PM
This revision was automatically updated to reflect the committed changes.

After this commit running cd /usr/tests/lib/libc/sys && kyua test cpuset_test renders the entire system unusable (and in Jenkins it's triggering a kernel panic)

Sorry I took so long - I confused your note that it should be reverted with a note that it *had been* reverted.